#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_EXTERNAL_FENCE_CAPABILITIES_SPEC_VERSION")]
pub const KHR_EXTERNAL_FENCE_CAPABILITIES_SPEC_VERSION: u32 = 1;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_EXTERNAL_FENCE_CAPABILITIES_EXTENSION_NAME")]
pub const KHR_EXTERNAL_FENCE_CAPABILITIES_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_external_fence_capabilities");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_PHYSICAL_DEVICE_EXTERNAL_FENCE_PROPERTIES_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetPhysicalDeviceExternalFencePropertiesKHR");
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagsKHR.html)) · Alias <br/> VkExternalFenceHandleTypeFlags - Bitmask of VkExternalFenceHandleTypeFlagBits\n[](#_c_specification)C Specification\n----------\n\n```\n// Provided by VK_VERSION_1_1\ntypedef VkFlags VkExternalFenceHandleTypeFlags;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_fence_capabilities\ntypedef VkExternalFenceHandleTypeFlags VkExternalFenceHandleTypeFlagsKHR;\n```\n[](#_description)Description\n----------\n\n[`crate::vk::ExternalFenceHandleTypeFlagBits`] is a bitmask type for setting a mask of\nzero or more [VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html).\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExportFenceCreateInfo`], [VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html), [`crate::vk::ExternalFenceProperties`]\n"]
#[doc(alias = "VkExternalFenceHandleTypeFlagsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalFenceHandleTypeFlagsKHR = crate::vk1_1::ExternalFenceHandleTypeFlags;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceFeatureFlagsKHR.html)) · Alias <br/> VkExternalFenceFeatureFlags - Bitmask of VkExternalFenceFeatureFlagBits\n[](#_c_specification)C Specification\n----------\n\n```\n// Provided by VK_VERSION_1_1\ntypedef VkFlags VkExternalFenceFeatureFlags;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_fence_capabilities\ntypedef VkExternalFenceFeatureFlags VkExternalFenceFeatureFlagsKHR;\n```\n[](#_description)Description\n----------\n\n[`crate::vk::ExternalFenceFeatureFlagBits`] is a bitmask type for setting a mask of\nzero or more [VkExternalFenceFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceFeatureFlagBits.html).\n[](#_see_also)See Also\n----------\n\n[VkExternalFenceFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceFeatureFlagBits.html), [`crate::vk::ExternalFenceProperties`]\n"]
#[doc(alias = "VkExternalFenceFeatureFlagsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalFenceFeatureFlagsKHR = crate::vk1_1::ExternalFenceFeatureFlags;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBitsKHR.html)) · Alias <br/> VkExternalFenceHandleTypeFlagBits - Bitmask of valid external fence handle types\n[](#_c_specification)C Specification\n----------\n\nBits which **may** be set in[`crate::vk::PhysicalDeviceExternalFenceInfo::handle_type`], and in the`exportFromImportedHandleTypes` and `compatibleHandleTypes` members\nof [`crate::vk::ExternalFenceProperties`], to indicate external fence handle types,\nare:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef enum VkExternalFenceHandleTypeFlagBits {\n    VK_EXTERNAL_FENCE_HANDLE_TYPE_OPAQUE_FD_BIT = 0x00000001,\n    VK_EXTERNAL_FENCE_HANDLE_TYPE_OPAQUE_WIN32_BIT = 0x00000002,\n    VK_EXTERNAL_FENCE_HANDLE_TYPE_OPAQUE_WIN32_KMT_BIT = 0x00000004,\n    VK_EXTERNAL_FENCE_HANDLE_TYPE_SYNC_FD_BIT = 0x00000008,\n  // Provided by VK_KHR_external_fence_capabilities\n    VK_EXTERNAL_FENCE_HANDLE_TYPE_OPAQUE_FD_BIT_KHR = VK_EXTERNAL_FENCE_HANDLE_TYPE_OPAQUE_FD_BIT,\n  // Provided by VK_KHR_external_fence_capabilities\n    VK_EXTERNAL_FENCE_HANDLE_TYPE_OPAQUE_WIN32_BIT_KHR = VK_EXTERNAL_FENCE_HANDLE_TYPE_OPAQUE_WIN32_BIT,\n  // Provided by VK_KHR_external_fence_capabilities\n    VK_EXTERNAL_FENCE_HANDLE_TYPE_OPAQUE_WIN32_KMT_BIT_KHR = VK_EXTERNAL_FENCE_HANDLE_TYPE_OPAQUE_WIN32_KMT_BIT,\n  // Provided by VK_KHR_external_fence_capabilities\n    VK_EXTERNAL_FENCE_HANDLE_TYPE_SYNC_FD_BIT_KHR = VK_EXTERNAL_FENCE_HANDLE_TYPE_SYNC_FD_BIT,\n} VkExternalFenceHandleTypeFlagBits;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_fence_capabilities\ntypedef VkExternalFenceHandleTypeFlagBits VkExternalFenceHandleTypeFlagBitsKHR;\n```\n[](#_description)Description\n----------\n\n* [`crate::vk::ExternalFenceHandleTypeFlagBits::OPAQUE_FD`] specifies a POSIX file\n  descriptor handle that has only limited valid usage outside of Vulkan\n  and other compatible APIs.\n  It **must** be compatible with the POSIX system calls `dup`, `dup2`,`close`, and the non-standard system call `dup3`.\n  Additionally, it **must** be transportable over a socket using an`SCM_RIGHTS` control message.\n  It owns a reference to the underlying synchronization primitive\n  represented by its Vulkan fence object.\n\n* [`crate::vk::ExternalFenceHandleTypeFlagBits::OPAQUE_WIN32`] specifies an NT\n  handle that has only limited valid usage outside of Vulkan and other\n  compatible APIs.\n  It **must** be compatible with the functions `DuplicateHandle`,`CloseHandle`, `CompareObjectHandles`, `GetHandleInformation`,\n  and `SetHandleInformation`.\n  It owns a reference to the underlying synchronization primitive\n  represented by its Vulkan fence object.\n\n* [`crate::vk::ExternalFenceHandleTypeFlagBits::OPAQUE_WIN32_KMT`] specifies a\n  global share handle that has only limited valid usage outside of Vulkan\n  and other compatible APIs.\n  It is not compatible with any native APIs.\n  It does not own a reference to the underlying synchronization primitive\n  represented by its Vulkan fence object, and will therefore become\n  invalid when all Vulkan fence objects associated with it are destroyed.\n\n* [`crate::vk::ExternalFenceHandleTypeFlagBits::SYNC_FD`] specifies a POSIX file\n  descriptor handle to a Linux Sync File or Android Fence.\n  It can be used with any native API accepting a valid sync file or fence\n  as input.\n  It owns a reference to the underlying synchronization primitive\n  associated with the file descriptor.\n  Implementations which support importing this handle type **must** accept\n  any type of sync or fence FD supported by the native system they are\n  running on.\n\nSome external fence handle types can only be shared within the same\nunderlying physical device and/or the same driver version, as defined in the\nfollowing table:\n\n|                    Handle type                     |[`crate::vk::PhysicalDeviceIDProperties`]::`driverUUID`|[`crate::vk::PhysicalDeviceIDProperties`]::`deviceUUID`|\n|----------------------------------------------------|--------------------------------------------|--------------------------------------------|\n|   [`crate::vk::ExternalFenceHandleTypeFlagBits::OPAQUE_FD`]    |                 Must match                 |                 Must match                 |\n|  [`crate::vk::ExternalFenceHandleTypeFlagBits::OPAQUE_WIN32`]  |                 Must match                 |                 Must match                 |\n|[`crate::vk::ExternalFenceHandleTypeFlagBits::OPAQUE_WIN32_KMT`]|                 Must match                 |                 Must match                 |\n|    [`crate::vk::ExternalFenceHandleTypeFlagBits::SYNC_FD`]     |               No restriction               |               No restriction               |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalFenceHandleTypeFlagBits`], [`crate::vk::FenceGetFdInfoKHR`], [`crate::vk::FenceGetWin32HandleInfoKHR`], [`crate::vk::ImportFenceFdInfoKHR`], [`crate::vk::ImportFenceWin32HandleInfoKHR`], [`crate::vk::PhysicalDeviceExternalFenceInfo`]\n"]
#[doc(alias = "VkExternalFenceHandleTypeFlagBitsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalFenceHandleTypeFlagBitsKHR = crate::vk1_1::ExternalFenceHandleTypeFlagBits;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceFeatureFlagBitsKHR.html)) · Alias <br/> VkExternalFenceFeatureFlagBits - Bitfield describing features of an external fence handle type\n[](#_c_specification)C Specification\n----------\n\nBits which **may** be set in[`crate::vk::ExternalFenceProperties::external_fence_features`], indicating\nfeatures of a fence external handle type, are:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef enum VkExternalFenceFeatureFlagBits {\n    VK_EXTERNAL_FENCE_FEATURE_EXPORTABLE_BIT = 0x00000001,\n    VK_EXTERNAL_FENCE_FEATURE_IMPORTABLE_BIT = 0x00000002,\n  // Provided by VK_KHR_external_fence_capabilities\n    VK_EXTERNAL_FENCE_FEATURE_EXPORTABLE_BIT_KHR = VK_EXTERNAL_FENCE_FEATURE_EXPORTABLE_BIT,\n  // Provided by VK_KHR_external_fence_capabilities\n    VK_EXTERNAL_FENCE_FEATURE_IMPORTABLE_BIT_KHR = VK_EXTERNAL_FENCE_FEATURE_IMPORTABLE_BIT,\n} VkExternalFenceFeatureFlagBits;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_fence_capabilities\ntypedef VkExternalFenceFeatureFlagBits VkExternalFenceFeatureFlagBitsKHR;\n```\n[](#_description)Description\n----------\n\n* [`crate::vk::ExternalFenceFeatureFlagBits::EXPORTABLE`] specifies handles of this\n  type **can** be exported from Vulkan fence objects.\n\n* [`crate::vk::ExternalFenceFeatureFlagBits::IMPORTABLE`] specifies handles of this\n  type **can** be imported to Vulkan fence objects.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalFenceFeatureFlagBits`]\n"]
#[doc(alias = "VkExternalFenceFeatureFlagBitsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalFenceFeatureFlagBitsKHR = crate::vk1_1::ExternalFenceFeatureFlagBits;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceExternalFenceInfoKHR.html)) · Alias <br/> VkPhysicalDeviceExternalFenceInfo - Structure specifying fence creation parameters.\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceExternalFenceInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkPhysicalDeviceExternalFenceInfo {\n    VkStructureType                      sType;\n    const void*                          pNext;\n    VkExternalFenceHandleTypeFlagBits    handleType;\n} VkPhysicalDeviceExternalFenceInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_fence_capabilities\ntypedef VkPhysicalDeviceExternalFenceInfo VkPhysicalDeviceExternalFenceInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `handleType` is a [VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html) value\n  specifying an external fence handle type for which capabilities will be\n  returned.\n[](#_description)Description\n----------\n\n|   |Note<br/><br/>Handles of type [`crate::vk::ExternalFenceHandleTypeFlagBits::SYNC_FD`] generated by<br/>the implementation may represent either Linux Sync Files or Android Fences<br/>at the implementation’s discretion.<br/>Applications **should** only use operations defined for both types of file<br/>descriptors, unless they know via means external to Vulkan the type of the<br/>file descriptor, or are prepared to deal with the system-defined operation<br/>failures resulting from using the wrong type.|\n|---|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceExternalFenceInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_EXTERNAL_FENCE_INFO`]\n\n* []() VUID-VkPhysicalDeviceExternalFenceInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkPhysicalDeviceExternalFenceInfo-handleType-parameter  \n  `handleType` **must** be a valid [VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html) value\n[](#_see_also)See Also\n----------\n\n[VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html), [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalFenceProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalFenceProperties`]\n"]
#[doc(alias = "VkPhysicalDeviceExternalFenceInfoKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceExternalFenceInfoKHR = crate::vk1_1::PhysicalDeviceExternalFenceInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceExternalFenceInfoKHR.html)) · Alias <br/> VkPhysicalDeviceExternalFenceInfo - Structure specifying fence creation parameters.\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceExternalFenceInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkPhysicalDeviceExternalFenceInfo {\n    VkStructureType                      sType;\n    const void*                          pNext;\n    VkExternalFenceHandleTypeFlagBits    handleType;\n} VkPhysicalDeviceExternalFenceInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_fence_capabilities\ntypedef VkPhysicalDeviceExternalFenceInfo VkPhysicalDeviceExternalFenceInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `handleType` is a [VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html) value\n  specifying an external fence handle type for which capabilities will be\n  returned.\n[](#_description)Description\n----------\n\n|   |Note<br/><br/>Handles of type [`crate::vk::ExternalFenceHandleTypeFlagBits::SYNC_FD`] generated by<br/>the implementation may represent either Linux Sync Files or Android Fences<br/>at the implementation’s discretion.<br/>Applications **should** only use operations defined for both types of file<br/>descriptors, unless they know via means external to Vulkan the type of the<br/>file descriptor, or are prepared to deal with the system-defined operation<br/>failures resulting from using the wrong type.|\n|---|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceExternalFenceInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_EXTERNAL_FENCE_INFO`]\n\n* []() VUID-VkPhysicalDeviceExternalFenceInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkPhysicalDeviceExternalFenceInfo-handleType-parameter  \n  `handleType` **must** be a valid [VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html) value\n[](#_see_also)See Also\n----------\n\n[VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html), [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalFenceProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalFenceProperties`]\n"]
#[doc(alias = "VkPhysicalDeviceExternalFenceInfoKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceExternalFenceInfoKHRBuilder<'a> = crate::vk1_1::PhysicalDeviceExternalFenceInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFencePropertiesKHR.html)) · Alias <br/> VkExternalFenceProperties - Structure describing supported external fence handle features\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ExternalFenceProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkExternalFenceProperties {\n    VkStructureType                   sType;\n    void*                             pNext;\n    VkExternalFenceHandleTypeFlags    exportFromImportedHandleTypes;\n    VkExternalFenceHandleTypeFlags    compatibleHandleTypes;\n    VkExternalFenceFeatureFlags       externalFenceFeatures;\n} VkExternalFenceProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_fence_capabilities\ntypedef VkExternalFenceProperties VkExternalFencePropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `exportFromImportedHandleTypes` is a bitmask of[VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html) indicating which types of\n  imported handle `handleType` **can** be exported from.\n\n* `compatibleHandleTypes` is a bitmask of[VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html) specifying handle types which**can** be specified at the same time as `handleType` when creating a\n  fence.\n\n* `externalFenceFeatures` is a bitmask of[VkExternalFenceFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceFeatureFlagBits.html) indicating the features of`handleType`.\n[](#_description)Description\n----------\n\nIf `handleType` is not supported by the implementation, then[`crate::vk::ExternalFenceProperties::external_fence_features`] will be set to\nzero.\n\nValid Usage (Implicit)\n\n* []() VUID-VkExternalFenceProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::EXTERNAL_FENCE_PROPERTIES`]\n\n* []() VUID-VkExternalFenceProperties-pNext-pNext  \n  `pNext` **must** be `NULL`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalFenceFeatureFlagBits`], [`crate::vk::ExternalFenceHandleTypeFlagBits`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalFenceProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalFenceProperties`]\n"]
#[doc(alias = "VkExternalFencePropertiesKHR")]
#[allow(non_camel_case_types)]
pub type ExternalFencePropertiesKHR = crate::vk1_1::ExternalFenceProperties;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFencePropertiesKHR.html)) · Alias <br/> VkExternalFenceProperties - Structure describing supported external fence handle features\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ExternalFenceProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkExternalFenceProperties {\n    VkStructureType                   sType;\n    void*                             pNext;\n    VkExternalFenceHandleTypeFlags    exportFromImportedHandleTypes;\n    VkExternalFenceHandleTypeFlags    compatibleHandleTypes;\n    VkExternalFenceFeatureFlags       externalFenceFeatures;\n} VkExternalFenceProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_fence_capabilities\ntypedef VkExternalFenceProperties VkExternalFencePropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `exportFromImportedHandleTypes` is a bitmask of[VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html) indicating which types of\n  imported handle `handleType` **can** be exported from.\n\n* `compatibleHandleTypes` is a bitmask of[VkExternalFenceHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceHandleTypeFlagBits.html) specifying handle types which**can** be specified at the same time as `handleType` when creating a\n  fence.\n\n* `externalFenceFeatures` is a bitmask of[VkExternalFenceFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalFenceFeatureFlagBits.html) indicating the features of`handleType`.\n[](#_description)Description\n----------\n\nIf `handleType` is not supported by the implementation, then[`crate::vk::ExternalFenceProperties::external_fence_features`] will be set to\nzero.\n\nValid Usage (Implicit)\n\n* []() VUID-VkExternalFenceProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::EXTERNAL_FENCE_PROPERTIES`]\n\n* []() VUID-VkExternalFenceProperties-pNext-pNext  \n  `pNext` **must** be `NULL`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalFenceFeatureFlagBits`], [`crate::vk::ExternalFenceHandleTypeFlagBits`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalFenceProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalFenceProperties`]\n"]
#[doc(alias = "VkExternalFencePropertiesKHR")]
#[allow(non_camel_case_types)]
pub type ExternalFencePropertiesKHRBuilder<'a> = crate::vk1_1::ExternalFencePropertiesBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceExternalFencePropertiesKHR.html)) · Alias <br/> vkGetPhysicalDeviceExternalFenceProperties - Function for querying external fence handle capabilities.\n[](#_c_specification)C Specification\n----------\n\nFences **may** support import and export of their[payload](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-fences-payloads) to external handles.\nTo query the external handle types supported by fences, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetPhysicalDeviceExternalFenceProperties(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalFenceInfo*    pExternalFenceInfo,\n    VkExternalFenceProperties*                  pExternalFenceProperties);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_external_fence_capabilities\nvoid vkGetPhysicalDeviceExternalFencePropertiesKHR(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalFenceInfo*    pExternalFenceInfo,\n    VkExternalFenceProperties*                  pExternalFenceProperties);\n```\n[](#_parameters)Parameters\n----------\n\n* `physicalDevice` is the physical device from which to query the\n  fence capabilities.\n\n* `pExternalFenceInfo` is a pointer to a[`crate::vk::PhysicalDeviceExternalFenceInfo`] structure describing the\n  parameters that would be consumed by [`crate::vk::PFN_vkCreateFence`].\n\n* `pExternalFenceProperties` is a pointer to a[`crate::vk::ExternalFenceProperties`] structure in which capabilities are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceExternalFenceProperties-physicalDevice-parameter  \n  `physicalDevice` **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceExternalFenceProperties-pExternalFenceInfo-parameter  \n  `pExternalFenceInfo` **must** be a valid pointer to a valid [`crate::vk::PhysicalDeviceExternalFenceInfo`] structure\n\n* []() VUID-vkGetPhysicalDeviceExternalFenceProperties-pExternalFenceProperties-parameter  \n  `pExternalFenceProperties` **must** be a valid pointer to a [`crate::vk::ExternalFenceProperties`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalFenceProperties`], [`crate::vk::PhysicalDevice`], [`crate::vk::PhysicalDeviceExternalFenceInfo`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetPhysicalDeviceExternalFencePropertiesKHR = crate::vk1_1::PFN_vkGetPhysicalDeviceExternalFenceProperties;
#[doc = "Provided by [`crate::extensions::khr_external_fence_capabilities`]"]
impl crate::vk1_0::StructureType {
    pub const PHYSICAL_DEVICE_EXTERNAL_FENCE_INFO_KHR: Self = Self::PHYSICAL_DEVICE_EXTERNAL_FENCE_INFO;
    pub const EXTERNAL_FENCE_PROPERTIES_KHR: Self = Self::EXTERNAL_FENCE_PROPERTIES;
}
#[doc = "Provided by [`crate::extensions::khr_external_fence_capabilities`]"]
impl crate::vk1_1::ExternalFenceHandleTypeFlagBits {
    pub const OPAQUE_FD_KHR: Self = Self::OPAQUE_FD;
    pub const OPAQUE_WIN32_KHR: Self = Self::OPAQUE_WIN32;
    pub const OPAQUE_WIN32_KMT_KHR: Self = Self::OPAQUE_WIN32_KMT;
    pub const SYNC_FD_KHR: Self = Self::SYNC_FD;
}
#[doc = "Provided by [`crate::extensions::khr_external_fence_capabilities`]"]
impl crate::vk1_1::ExternalFenceFeatureFlagBits {
    pub const EXPORTABLE_KHR: Self = Self::EXPORTABLE;
    pub const IMPORTABLE_KHR: Self = Self::IMPORTABLE;
}
#[doc = "Provided by [`crate::extensions::khr_external_fence_capabilities`]"]
impl crate::InstanceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceExternalFencePropertiesKHR.html)) · Function <br/> vkGetPhysicalDeviceExternalFenceProperties - Function for querying external fence handle capabilities.\n[](#_c_specification)C Specification\n----------\n\nFences **may** support import and export of their[payload](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-fences-payloads) to external handles.\nTo query the external handle types supported by fences, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetPhysicalDeviceExternalFenceProperties(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalFenceInfo*    pExternalFenceInfo,\n    VkExternalFenceProperties*                  pExternalFenceProperties);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_external_fence_capabilities\nvoid vkGetPhysicalDeviceExternalFencePropertiesKHR(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalFenceInfo*    pExternalFenceInfo,\n    VkExternalFenceProperties*                  pExternalFenceProperties);\n```\n[](#_parameters)Parameters\n----------\n\n* `physicalDevice` is the physical device from which to query the\n  fence capabilities.\n\n* `pExternalFenceInfo` is a pointer to a[`crate::vk::PhysicalDeviceExternalFenceInfo`] structure describing the\n  parameters that would be consumed by [`crate::vk::PFN_vkCreateFence`].\n\n* `pExternalFenceProperties` is a pointer to a[`crate::vk::ExternalFenceProperties`] structure in which capabilities are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceExternalFenceProperties-physicalDevice-parameter  \n  `physicalDevice` **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceExternalFenceProperties-pExternalFenceInfo-parameter  \n  `pExternalFenceInfo` **must** be a valid pointer to a valid [`crate::vk::PhysicalDeviceExternalFenceInfo`] structure\n\n* []() VUID-vkGetPhysicalDeviceExternalFenceProperties-pExternalFenceProperties-parameter  \n  `pExternalFenceProperties` **must** be a valid pointer to a [`crate::vk::ExternalFenceProperties`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalFenceProperties`], [`crate::vk::PhysicalDevice`], [`crate::vk::PhysicalDeviceExternalFenceInfo`]\n"]
    #[doc(alias = "vkGetPhysicalDeviceExternalFencePropertiesKHR")]
    pub unsafe fn get_physical_device_external_fence_properties_khr(&self, physical_device: crate::vk1_0::PhysicalDevice, external_fence_info: &crate::vk1_1::PhysicalDeviceExternalFenceInfo, external_fence_properties: Option<crate::vk1_1::ExternalFenceProperties>) -> crate::vk1_1::ExternalFenceProperties {
        let _function = self.get_physical_device_external_fence_properties_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut external_fence_properties = match external_fence_properties {
            Some(v) => v,
            None => Default::default(),
        };
        let _return = _function(physical_device as _, external_fence_info as _, &mut external_fence_properties);
        {
            external_fence_properties.p_next = std::ptr::null_mut() as _;
            external_fence_properties
        }
    }
}
